Scriptname RentRoomScript extends Actor  Conditional
{script for anyone who rents a room}

ObjectReference Property Bed  Auto  
{bed to rent}

WIFunctionsScript Property WI Auto
{Pointer to WIFunctionsScript attached to WI quest}

function RentRoom_(float hours, int cost, Form currency)
	Bed.SetActorOwner(Game.GetPlayer().GetActorBase())
	RegisterForSingleUpdateGameTime(hours)
	if (currency && cost > 0)
		Game.GetPlayer().RemoveItem(currency, cost)
	endif
	; used to conditionalize innkeeper dialogue
	SetActorValue("Variable09", 1.0)
	
	ShowPlayerRoom()
endfunction

; rent room or clear rental
function RentRoom(DialogueGenericScript pQuestScript)
	RentRoom_(pQuestScript.RentHours, pQuestScript.RoomRentalCost.GetValueInt(), pQuestScript.Gold)
endFunction

function ClearRoom()
; 	debug.trace(self + " ClearRoom called on RentRoomScript - room rental expired")
	; clear ownership - either rental expired or I died
	Bed.SetActorOwner((self as Actor).GetActorBase())
	UnregisterForUpdateGameTime()
	; used to conditionalize innkeeper dialogue
	SetActorValue("Variable09", 0.0)
endFunction

; when this is called, reset the ownership on the bed
event OnUpdateGameTime()
	ClearRoom()
endEvent

; if I die, clear the room rental as well, to stop the timer
Event OnDeath(Actor akKiller)
	ClearRoom()
endEvent

function ShowPlayerRoom()
	GlobalVariable ShowRoomNewerShow = Game.GetFormFromFile(0x00000807, "TavernAIFix.esp") as GlobalVariable
	if (ShowRoomNewerShow && ShowRoomNewerShow.GetValue() == 1.0)
		return
	endif

	FormList ShowRoomExcludeList = Game.GetFormFromFile(0x00000806, "TavernAIFix.esp") as FormList
	if (ShowRoomExcludeList)
		if (ShowRoomExcludeList.HasForm(GetBaseObject()))
			return
		endif
		ShowRoomExcludeList.AddForm(GetBaseObject())
	endif

	WI.ShowPlayerRoom(self, Bed)	
endfunction


; Become a Bard functions.

; free room
function FreeRoom(float RentHours)
	;Debug.Notification("Free room function called")
	RentRoom_(RentHours, 0, none)
endFunction


; Extended Stay functions.

function RentRoom3Day(ModExtendedStayVariables pQuestScript)
	RentRoom_(pQuestScript.RentHours3Day, pQuestScript.RoomRentalCost3DayGlobal.GetValueInt(), pQuestScript.Gold)
endFunction

function RentRoom7Day(ModExtendedStayVariables pQuestScript)
	RentRoom_(pQuestScript.RentHours7Day, pQuestScript.RoomRentalCost7DayGlobal.GetValueInt(), pQuestScript.Gold)
endFunction

function RentRoom30Day(ModExtendedStayVariables pQuestScript)
	RentRoom_(pQuestScript.RentHours30Day, pQuestScript.RoomRentalCost30DayGlobal.GetValueInt(), pQuestScript.Gold)
endFunction